/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// メールテンプレートと別フレームのエラー情報クラス
// 
//
//	変更履歴
//	2004/01/08 新規作成	T.Nishiki 
package jp.co.ntt.lms.xms.common.mail;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import jp.co.ntt.lms.xms.framework.XmsScreenBean;

/**
 * メールテンプレートと別フレームのエラー情報クラス。<br>
 * 
 * @author T.Nishiki
 */
public class InputFrameErrorBean extends XmsScreenBean {
	/**
	 * ボタン表示タイプ：なし。<br>
	 */
	public final static int BUTTON_TYPE_NULL = 0;
	/**
	 * ボタン表示タイプ：閉じるボタン。<br>
	 */
	public final static int BUTTON_TYPE_CLOSE = 1;

	/**
	 * ボタン表示タイプ：戻るボタン。<br>
	 */
	public final static int BUTTON_TYPE_RETURN = 2;
	
	/**
	 * ボタン表示タイプ。
	 */
	private int buttonType;

	/**
	 * エラーメッセージ。
	 */
	private String errorMessage;

	/**
	 * アクションID。<br>
	 * エラー画面に戻るボタンを設定した場合の戻り先のアクションID。
	 * 
	 * @see #BUTTON_TYPE_RETURN
	 */
	private String actionId;

	/**
	 * アクションID以外のパラメータ。
	 * エラー画面に戻るボタンを設定した場合の戻り先のリクエストパラメータ。
	 * 
	 * @see #BUTTON_TYPE_RETURN
	 */
	private Map parameterMap;

	/**
	 * エラー画面のウィンドウタイトル。
	 */
	private String windowTitle;
	
	/**
	 * エラー画面のヘッダ画像ファイルパス。
	 */
	private String headImagePath;

	/**
	 * コンストラクタ。<br>
	 * 
	 */
	public InputFrameErrorBean() {
		buttonType = BUTTON_TYPE_RETURN;
		errorMessage = null;
		actionId = null;
		parameterMap = new HashMap();
	}

	/**
	 * アクションIDを取得する。<br>
	 * @return アクションID。
	 */
	public String getActionId() {
		return actionId;
	}

	/**
	 * ボタン表示タイプを取得する。<br>
	 * @return ボタン表示タイプ。
	 * @see #BUTTON_TYPE_NULL
	 * @see #BUTTON_TYPE_CLOSE
	 * @see #BUTTON_TYPE_RETURN
	 */
	public int getButtonType() {
		return buttonType;
	}

	/**
	 * エラーメッセージを取得する。<br>
	 * @return エラーメッセージ。
	 */
	public String getErrorMessage() {
		return errorMessage;
	}

	/**
	 * エラー画面のヘッダ画像ファイルのパスを取得する。<br>
	 * @return ヘッダ画像ファイルのパス。
	 */
	public String getHeadImagePath() {
		return headImagePath;
	}

	/**
	 * エラー画面のウィンドウタイトルを取得する。<br>
	 * @return String
	 */
	public String getWindowTitle() {
		return windowTitle;
	}

	/**
	 * エラーメッセージを設定する。<br>
	 * @param errorMessage エラーメッセージ文字列。
	 */
	public void setErrorMessage( String errorMessage ) {
		this.errorMessage = errorMessage;
	}

	/**
	 * アクションIDを設定する。<br>
	 * @param actionId アクションID。
	 */
	public void setActionId(String actionId) {
		this.actionId = actionId;
	}

	/**
	 * リクエスト・パラメータを追加する。<br>
	 * 指定したキーと値のパラメータを保持する。
	 * 同名のパラメータを保持していた場合は、追加する形で保持する（上書きしない）。
	 * @param name パラメータ名称。
	 * @param value パラメータ値。
	 */
	public void addParameter( String name, String value ) {
		// 同名ですでに登録されているリストを取得する。
		// なければマップに追加する。
		// 新しいパラメータをリストに追加する。
		List parameterList = null;
		parameterList = getParameters( name, true );
		parameterList.add( value );
	}

	/**
	 * ボタン表示タイプを取得する。<br>
	 * @param buttonType ボタン表示タイプ。
	 * @see #BUTTON_TYPE_NULL
	 * @see #BUTTON_TYPE_CLOSE
	 * @see #BUTTON_TYPE_RETURN
	 */
	public void setButtonType(int buttonType) {
		this.buttonType = buttonType;
	}

	/**
	 * エラー画面のヘッダー画像ファイルパスを設定する。<br>
	 * @param headImagePath ヘッダー画像ファイルパス。
	 */
	public void setHeadImagePath(String headImagePath) {
		this.headImagePath = headImagePath;
	}

	/**
	 * エラー画面のウィンドウタイトルを設定する。<br>
	 * @param windowTitle ウィンドウタイトル。
	 */
	public void setWindowTitle(String windowTitle) {
		this.windowTitle = windowTitle;
	}

	/**
	 * パラメータ名称を取得する。<br>
	 * 
	 * @return パラメータ名称（String）を要素とするSet。
	 */
	public Set getParameterNames( ) {
		Set returnValue = null;
		returnValue = parameterMap.keySet();
		return returnValue;
	}

	/**
	 * パラメータを取得する。<br>
	 * @param name パラメータ名称。
	 * @return keyに対応するパラメータ値（String）を要素とするList。
	 *          対応するパラメータが存在しない場合はnullを戻す。
	 */
	public List getParameters( String name ) {
		List parameterList = null;
		parameterList = getParameters(name, false);
		return parameterList;
	}

	/**
	 * パラメータを取得する。<br>
	 * @param name パラメータ名称。
	 * @param create 対応するパラメータが存在しないとき、
	 *                リストを作成する場合はtrueを渡す。
	 * @return keyに対応するパラメータ値（String）を要素とするList。
	 */
	private List getParameters( String name, boolean create ) {
		List parameterList = null;
		parameterList = (List)parameterMap.get( name );
		// パラメータが存在せず、作成する場合
		if (parameterList == null && create == true ) {
			parameterList = new ArrayList();
			parameterMap.put(name, parameterList);
		}
		return parameterList;
	}
}
